package com.akamai.osmf.samples.presenter
{
	import com.akamai.osmf.samples.view.BaseVideoView;
	
	import flash.utils.ByteArray;
	
	import org.osmf.events.DRMEvent;
	import org.osmf.events.MediaPlayerCapabilityChangeEvent;
	import org.osmf.media.MediaFactory;
	import org.osmf.media.MediaPlayer;
	import org.osmf.net.StreamType;
	import org.osmf.net.StreamingURLResource;
	import org.osmf.traits.DRMState;
	import org.osmf.traits.DRMTrait;
	import org.osmf.traits.MediaTraitType;
	
	public class FlashAccessTokenAuthControlBarPresenter extends BaseControlBarPresenter
	{
		private var resource:StreamingURLResource;

		private var drmTrait:DRMTrait;
		
		public function FlashAccessTokenAuthControlBarPresenter(view:BaseVideoView, mediaPlayer:MediaPlayer, mediaFactory:MediaFactory, mediaResource:String)
		{	
			resource = new StreamingURLResource(mediaResource,StreamType.LIVE_OR_RECORDED);
			super(view, mediaPlayer, mediaFactory, mediaResource);
		}
		
		override protected function setupMediaPlayer():void
		{
			mediaPlayer.autoPlay = false;
			setupMediaPlayerListeners();
			
			//Flash Access Listener
			mediaPlayer.addEventListener(MediaPlayerCapabilityChangeEvent.HAS_DRM_CHANGE, onDRMTraitAdded);
			mediaPlayer.media = mediaFactory.createMediaElement(resource);
			
		}
		
		protected function onDRMTraitAdded(event:MediaPlayerCapabilityChangeEvent):void
		{
			//Flash Access Listener
			mediaPlayer.removeEventListener(MediaPlayerCapabilityChangeEvent.HAS_DRM_CHANGE, onDRMTraitAdded);
			
			drmTrait = mediaPlayer.media.getTrait(MediaTraitType.DRM) as DRMTrait;
			drmTrait.addEventListener(DRMEvent.DRM_STATE_CHANGE, onDRMStateChange);
			
		}
		
		//Flash Access DRM Change Listener - You set the auth token here.
		protected function onDRMStateChange(event:DRMEvent):void
		{
			if (event.drmState == DRMState.AUTHENTICATING)
			{
				drmTrait.removeEventListener(DRMEvent.DRM_STATE_CHANGE, onDRMStateChange);
				mediaPlayer.authenticateWithToken(getToken());
			}
			
			function getToken():ByteArray
			{
				var token:ByteArray = new ByteArray();
				token[0] = 0x61;
				token[1] = 0x62;
				token[2] = 0x63;
				token[3] = 0x64;
				token[4] = 0x65;
				return token;
			}
		}
	}
}
